using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_GestionDocumental._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_GestionDocumental._1_Datos
{
    public class GTD_PlantillasDocumentosArchivos_Datos : ABS_Datos
    {
        #region Listado
       
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {}
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                       nameof(GTD_PlantillasDocumentosArchivos.id) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.descripcion) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.archivo) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.rotacion) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.esImagen) +
                " FROM " + nameof(GTD_PlantillasDocumentosArchivos) +
                " WHERE " + nameof(GTD_PlantillasDocumentosArchivos.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<GTD_PlantillasDocumentosArchivos>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private GTD_PlantillasDocumentosArchivos g_mdl_GTD_PlantillasDocumentosArchivos = null;
        public GTD_PlantillasDocumentosArchivos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(GTD_PlantillasDocumentosArchivos) + "." + nameof(GTD_PlantillasDocumentosArchivos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_GTD_PlantillasDocumentosArchivos;
        }
        public GTD_PlantillasDocumentosArchivos Obtener_Modelo_Por_IdPlantillaDocumentoCabecera(long _lng_idPlantillaDocumentoCabecera)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(GTD_PlantillasDocumentosArchivos) + "." + nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "=@idPlantillaDocumentoCabecera";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPlantillaDocumentoCabecera",  _lng_idPlantillaDocumentoCabecera)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Obtener_Modelo_Por_IdPlantillaDocumentoCabecera), true);
            }

            return g_mdl_GTD_PlantillasDocumentosArchivos;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_GTD_PlantillasDocumentosArchivos = obj_Exferia_Entities.Database.SqlQuery<GTD_PlantillasDocumentosArchivos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion

        #region Modelo Listado
        private List<GTD_PlantillasDocumentosArchivos> g_lst_GTD_PlantillasDocumentosArchivos = null;

        public List<GTD_PlantillasDocumentosArchivos> Obtener_ModeloListado_Por_IdPlantillaDocumentoCabecera(long _lng_idPlantillaDocumentoCabecera)
        {
            try
            {
                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(GTD_PlantillasDocumentosArchivos) + "." + nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "=@idPlantillaDocumentoCabecera";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPlantillaDocumentoCabecera",  _lng_idPlantillaDocumentoCabecera)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdPlantillaDocumentoCabecera), true);
            }

            return g_lst_GTD_PlantillasDocumentosArchivos;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                  object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_GTD_PlantillasDocumentosArchivos = obj_Exferia_Entities.Database.SqlQuery<GTD_PlantillasDocumentosArchivos>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                       nameof(GTD_PlantillasDocumentosArchivos.id) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.descripcion) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.archivo) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.rotacion) + "," +
                       nameof(GTD_PlantillasDocumentosArchivos.esImagen) +
                " FROM " + nameof(GTD_PlantillasDocumentosArchivos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                GTD_PlantillasDocumentosArchivos mdl_GTD_PlantillasDocumentosArchivos_AGrabar = (GTD_PlantillasDocumentosArchivos)_mdl_obj;
                GTD_PlantillasDocumentosArchivos mdl_GTD_PlantillasDocumentosArchivos_DatosViejos = new GTD_PlantillasDocumentosArchivos();

                // Ver si existe ######################################################################
                GTD_PlantillasDocumentosArchivos mdl_GTD_PlantillasDocumentosArchivos_Final = Obtener_Modelo_Por_Id(mdl_GTD_PlantillasDocumentosArchivos_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_GTD_PlantillasDocumentosArchivos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GTD_PlantillasDocumentosArchivos_Final, mdl_GTD_PlantillasDocumentosArchivos_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GTD_PlantillasDocumentosArchivos_AGrabar, mdl_GTD_PlantillasDocumentosArchivos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GTD_PlantillasDocumentosArchivos) +
                                            " SET " +
                                                 nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "=@idPlantillaDocumentoCabecera," +
                                                 nameof(GTD_PlantillasDocumentosArchivos.descripcion) + "=@descripcion," +
                                                 nameof(GTD_PlantillasDocumentosArchivos.archivo) + "=@archivo," +
                                                 nameof(GTD_PlantillasDocumentosArchivos.rotacion) + "=@rotacion," +
                                                  nameof(GTD_PlantillasDocumentosArchivos.esImagen) + "=@esImagen " +
                                            " WHERE " +
                                                nameof(GTD_PlantillasDocumentosArchivos.id) + "=@id";


                    //Parametros
                    SqlParameter obj_SqlParameter_Archivo = new SqlParameter("@archivo", SqlDbType.Binary);
                    obj_SqlParameter_Archivo.Value = mdl_GTD_PlantillasDocumentosArchivos_Final.archivo; 

                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idPlantillaDocumentoCabecera", mdl_GTD_PlantillasDocumentosArchivos_Final.idPlantillaDocumentoCabecera),
                        new SqlParameter("@descripcion", mdl_GTD_PlantillasDocumentosArchivos_Final.descripcion),
                        obj_SqlParameter_Archivo,
                        new SqlParameter("@rotacion", mdl_GTD_PlantillasDocumentosArchivos_Final.rotacion),
                        mdl_GTD_PlantillasDocumentosArchivos_Final.esImagen != null
                        ?   new SqlParameter("@esImagen", mdl_GTD_PlantillasDocumentosArchivos_Final.esImagen.Value)
                        :   new SqlParameter("@esImagen",  DBNull.Value),
                        new SqlParameter("@id", mdl_GTD_PlantillasDocumentosArchivos_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_GTD_PlantillasDocumentosArchivos_Final.id;
                }
                //INSERT
                else
                {
                    mdl_GTD_PlantillasDocumentosArchivos_Final = new GTD_PlantillasDocumentosArchivos();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GTD_PlantillasDocumentosArchivos_AGrabar, mdl_GTD_PlantillasDocumentosArchivos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(GTD_PlantillasDocumentosArchivos) +
                                                " (" +
                                                        nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "," +
                                                        nameof(GTD_PlantillasDocumentosArchivos.descripcion) + "," +
                                                        nameof(GTD_PlantillasDocumentosArchivos.archivo) + "," +
                                                        nameof(GTD_PlantillasDocumentosArchivos.rotacion) + "," +
                                                        nameof(GTD_PlantillasDocumentosArchivos.esImagen) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(GTD_PlantillasDocumentosArchivos.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idPlantillaDocumentoCabecera," +
                                                    "@descripcion," +
                                                    "@archivo," +
                                                    "@rotacion," +
                                                    "@esImagen" +
                                                " ) ";
                    //Parametros
                    SqlParameter obj_SqlParameter_Archivo = new SqlParameter("@archivo", SqlDbType.Binary);
                    obj_SqlParameter_Archivo.Value = mdl_GTD_PlantillasDocumentosArchivos_Final.archivo;

                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPlantillaDocumentoCabecera", mdl_GTD_PlantillasDocumentosArchivos_Final.idPlantillaDocumentoCabecera),
                        new SqlParameter("@descripcion", mdl_GTD_PlantillasDocumentosArchivos_Final.descripcion),
                        obj_SqlParameter_Archivo,
                        new SqlParameter("@rotacion", mdl_GTD_PlantillasDocumentosArchivos_Final.rotacion),
                        mdl_GTD_PlantillasDocumentosArchivos_Final.esImagen != null
                        ?   new SqlParameter("@esImagen", mdl_GTD_PlantillasDocumentosArchivos_Final.esImagen.Value)
                        :   new SqlParameter("@esImagen",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(GTD_PlantillasDocumentosArchivos), mdl_GTD_PlantillasDocumentosArchivos_DatosViejos, mdl_GTD_PlantillasDocumentosArchivos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                GTD_PlantillasDocumentosArchivos mdl_GTD_PlantillasDocumentosArchivos_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_GTD_PlantillasDocumentosArchivos_Final != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM " + nameof(GTD_PlantillasDocumentosArchivos) +
                                            " WHERE " +
                                                nameof(GTD_PlantillasDocumentosArchivos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(GTD_PlantillasDocumentosArchivos), null, mdl_GTD_PlantillasDocumentosArchivos_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar_Por_IdPlantillaDocumentoCabecera(long _lng_idPlantillaDocumentoCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM " + nameof(GTD_PlantillasDocumentosArchivos) +
                                        " WHERE " +
                                            nameof(GTD_PlantillasDocumentosArchivos.idPlantillaDocumentoCabecera) + "=@idPlantillaDocumentoCabecera";
                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@idPlantillaDocumentoCabecera", _lng_idPlantillaDocumentoCabecera)
                };
                #endregion

                //Delete
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GTD_PlantillasDocumentosArchivos) + "/" + nameof(Borrar_Por_IdPlantillaDocumentoCabecera), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
